﻿using Microsoft.Xna.Framework;

// All extension methods on built-in types (of C# or MonoGame) go in this file.

namespace SemiColinGames {
  static class ExtensionMethods {
    // Vector2
    public static Vector2 Rotate(this Vector2 point, float angle) {
      float cos = FMath.Cos(angle);
      float sin = FMath.Sin(angle);
      return new Vector2(
        point.X * cos - point.Y * sin,
        point.Y * cos + point.X * sin);
    }

    // Point
    public static void Deconstruct(this Point point, out int x, out int y) =>
      (x, y) = (point.X, point.Y);
  }
}
